#include "bicg.dist_dynsched.h"
#include "polyrt.h"
#include <stdio.h>
#include <math.h>
#include <assert.h>
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))





int is_receiver_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  if (pi_2(3, ts2,_PB_NY,_PB_NX, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

int get_num_remote_dep_tasks_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  if (pi_2(3, ts2,_PB_NY,_PB_NX, nprocs) != my_rank) count++;;
}
/* End of CLooG code */


return count;
}

void remote_update_dep_tasks_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  if (pi_2(3, ts2,_PB_NY,_PB_NX, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2-lb_tasks_loop2_dim0)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_2(3, ts2,_PB_NY,_PB_NX,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_2(3, ts2,_PB_NY,_PB_NX,my_rank,nprocs); if (__is_multi_partitioned[2] || __is_block_cyclic[2]) affinity = -1; else affinity = pi_threads_2(3, ts2,_PB_NY,_PB_NX,my_rank,nprocs,num_threads); __Task task(2,3, ts2,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */

}

int get_num_local_dep_tasks_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  if (pi_2(3, ts2,_PB_NY,_PB_NX, nprocs) == my_rank) count++;;
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2-lb_tasks_loop2_dim0)+0]; if (captured_firing_count == 0) { if (pi_2(3, ts2,_PB_NY,_PB_NX, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_2(3, ts2,_PB_NY,_PB_NX,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_2(3, ts2,_PB_NY,_PB_NX,my_rank,nprocs); if (__is_multi_partitioned[2] || __is_block_cyclic[2]) affinity = -1; else affinity = pi_threads_2(3, ts2,_PB_NY,_PB_NX,my_rank,nprocs,num_threads); __Task task(2,3, ts2,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */

}

int get_num_remote_src_tasks_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int get_num_local_src_tasks_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int is_receiver_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 0) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  if (pi_3(1, ts2,_PB_NY,_PB_NX, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

int get_num_remote_dep_tasks_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 0) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  if (pi_3(1, ts2,_PB_NY,_PB_NX, nprocs) != my_rank) count++;;
}
/* End of CLooG code */


return count;
}

void remote_update_dep_tasks_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 0) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  if (pi_3(1, ts2,_PB_NY,_PB_NX, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2-lb_tasks_loop3_dim0)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_3(1, ts2,_PB_NY,_PB_NX,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_3(1, ts2,_PB_NY,_PB_NX,my_rank,nprocs); if (__is_multi_partitioned[3] || __is_block_cyclic[3]) affinity = -1; else affinity = pi_threads_3(1, ts2,_PB_NY,_PB_NX,my_rank,nprocs,num_threads); __Task task(3,1, ts2,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */

}

int get_num_local_dep_tasks_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 0) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  if (pi_3(1, ts2,_PB_NY,_PB_NX, nprocs) == my_rank) count++;;
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 0) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2-lb_tasks_loop3_dim0)+0]; if (captured_firing_count == 0) { if (pi_3(1, ts2,_PB_NY,_PB_NX, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_3(1, ts2,_PB_NY,_PB_NX,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_3(1, ts2,_PB_NY,_PB_NX,my_rank,nprocs); if (__is_multi_partitioned[3] || __is_block_cyclic[3]) affinity = -1; else affinity = pi_threads_3(1, ts2,_PB_NY,_PB_NX,my_rank,nprocs,num_threads); __Task task(3,1, ts2,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */

}

int get_num_remote_src_tasks_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int get_num_local_src_tasks_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int is_receiver_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return 0;
}

int get_num_remote_dep_tasks_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return count;
}

void remote_update_dep_tasks_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

}

int get_num_local_dep_tasks_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

}

int get_num_remote_src_tasks_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (ts1 == 3) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  if (pi_0(2, ts2, _PB_NY, _PB_NX, nprocs) != my_rank) count++;;
}
/* End of CLooG code */



return count;
}

int get_num_local_src_tasks_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (ts1 == 3) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  if (pi_0(2, ts2, _PB_NY, _PB_NX, nprocs) == my_rank) count++;;
}
/* End of CLooG code */



return count;
}

int is_receiver_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return 0;
}

int get_num_remote_dep_tasks_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return count;
}

void remote_update_dep_tasks_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

}

int get_num_local_dep_tasks_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

}

int get_num_remote_src_tasks_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NY >= 1) && (ts1 == 1) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  if (pi_1(0, ts2, _PB_NY, _PB_NX, nprocs) != my_rank) count++;;
}
/* End of CLooG code */



return count;
}

int get_num_local_src_tasks_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NY >= 1) && (ts1 == 1) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  if (pi_1(0, ts2, _PB_NY, _PB_NX, nprocs) == my_rank) count++;;
}
/* End of CLooG code */



return count;
}

int is_receiver_s_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  if (pi_2(3, ts2, _PB_NY, _PB_NX, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

void sigma_s_1_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int *receiver_list)
{
int __p;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  __p = pi_2(3, ts2, _PB_NY, _PB_NX,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
}
/* End of CLooG code */

}

int is_receiver_s_1_0(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NY-1)) {
  if (pi_2(3, ts2, _PB_NY, _PB_NX, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

int is_receiver_q_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 0) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  if (pi_3(1, ts2, _PB_NY, _PB_NX, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

void sigma_q_1_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int *receiver_list)
{
int __p;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 0) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  __p = pi_3(1, ts2, _PB_NY, _PB_NX,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
}
/* End of CLooG code */

}

int is_receiver_q_1_1(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NX >= 1) && (_PB_NY >= 1) && (ts1 == 0) && (ts2 >= 0) && (32*ts2 <= _PB_NX-1)) {
  if (pi_3(1, ts2, _PB_NY, _PB_NX, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

int is_receiver_s_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return 0;
}

void sigma_s_1_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_s_1_2(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_q_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return 0;
}

void sigma_q_1_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_q_1_3(int ts1, int ts2, int _PB_NY, int _PB_NX, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}
