#include <math.h>
#include <assert.h>
#include "pi_defs.h"
#include "polyrt.h"
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))

#ifndef __BLOCK_CYCLIC_BLOCK_SIZE
#define __BLOCK_CYCLIC_BLOCK_SIZE 1
#endif

int pi_0( int t1, int t5, int t7, int N, int n, int nprocs)
{
                int __lb0, __ub0;
                __lb0 = _LB_REPLACE_ME_DISTLOOG0t5;
                __ub0 = _UB_REPLACE_ME_DISTLOOG0t5;
                int __lb1, __ub1;
                __lb1 = _LB_REPLACE_ME_DISTLOOG0t7;
                __ub1 = _UB_REPLACE_ME_DISTLOOG0t7;
#ifdef __USE_BLOCK_CYCLIC
                    if (__is_block_cyclic[0])
                     return polyrt_two_dim_pi_block_cyclic(t5, __lb0, __ub0, t7, __lb1, __ub1, nprocs, __BLOCK_CYCLIC_BLOCK_SIZE);
                    else
 #endif
                    return polyrt_two_dim_pi(0, t5, __lb0, __ub0, t7, __lb1, __ub1, nprocs);
}
int pi_threads_0( int t1, int t5, int t7, int N, int n, int my_rank, int nprocs, int num_threads)
{
int lbp, ubp;
                    polyrt_multi_dim_loop_dist(_LB_REPLACE_ME_DISTLOOG0t5, _UB_REPLACE_ME_DISTLOOG0t5, nprocs, my_rank, 2, 0, &lbp, &ubp);
                    int __lb0, __ub0;
                    __lb0 = lbp;
                    __ub0 = ubp;
                    polyrt_multi_dim_loop_dist(_LB_REPLACE_ME_DISTLOOG0t7, _UB_REPLACE_ME_DISTLOOG0t7, nprocs, my_rank, 2, 1, &lbp, &ubp);
                    int __lb1, __ub1;
                    __lb1 = lbp;
                    __ub1 = ubp;
                        return polyrt_two_dim_pi(0, t5, __lb0, __ub0, t7, __lb1, __ub1, num_threads);
}
int pi_1( int t1, int t5, int t7, int N, int n, int nprocs)
{
                int __lb0, __ub0;
                __lb0 = _LB_REPLACE_ME_DISTLOOG1t5;
                __ub0 = _UB_REPLACE_ME_DISTLOOG1t5;
                int __lb1, __ub1;
                __lb1 = _LB_REPLACE_ME_DISTLOOG1t7;
                __ub1 = _UB_REPLACE_ME_DISTLOOG1t7;
#ifdef __USE_BLOCK_CYCLIC
                    if (__is_block_cyclic[1])
                     return polyrt_two_dim_pi_block_cyclic(t5, __lb0, __ub0, t7, __lb1, __ub1, nprocs, __BLOCK_CYCLIC_BLOCK_SIZE);
                    else
 #endif
                    return polyrt_two_dim_pi(1, t5, __lb0, __ub0, t7, __lb1, __ub1, nprocs);
}
int pi_threads_1( int t1, int t5, int t7, int N, int n, int my_rank, int nprocs, int num_threads)
{
int lbp, ubp;
                    polyrt_multi_dim_loop_dist(_LB_REPLACE_ME_DISTLOOG1t5, _UB_REPLACE_ME_DISTLOOG1t5, nprocs, my_rank, 2, 0, &lbp, &ubp);
                    int __lb0, __ub0;
                    __lb0 = lbp;
                    __ub0 = ubp;
                    polyrt_multi_dim_loop_dist(_LB_REPLACE_ME_DISTLOOG1t7, _UB_REPLACE_ME_DISTLOOG1t7, nprocs, my_rank, 2, 1, &lbp, &ubp);
                    int __lb1, __ub1;
                    __lb1 = lbp;
                    __ub1 = ubp;
                        return polyrt_two_dim_pi(1, t5, __lb0, __ub0, t7, __lb1, __ub1, num_threads);
}
int pi_2( int t1, int t5, int N, int n, int nprocs)
{
                int __lb0, __ub0;
                __lb0 = _LB_REPLACE_ME_DISTLOOG2t5;
                __ub0 = _UB_REPLACE_ME_DISTLOOG2t5;
#ifdef __USE_BLOCK_CYCLIC
                    if (__is_block_cyclic[2])
                     return polyrt_one_dim_pi_block_cyclic(t5, __lb0, __ub0, nprocs, __BLOCK_CYCLIC_BLOCK_SIZE);
                    else
 #endif
                    return polyrt_one_dim_pi(t5, __lb0, __ub0, nprocs);
}
int pi_threads_2( int t1, int t5, int N, int n, int my_rank, int nprocs, int num_threads)
{
int lbp, ubp;
                    polyrt_multi_dim_loop_dist(_LB_REPLACE_ME_DISTLOOG2t5, _UB_REPLACE_ME_DISTLOOG2t5, nprocs, my_rank, 1, 0, &lbp, &ubp);
                    int __lb0, __ub0;
                    __lb0 = lbp;
                    __ub0 = ubp;
                        return polyrt_one_dim_pi(t5, __lb0, __ub0, num_threads);
}
int pi_3( int t1, int t5, int t7, int N, int n, int nprocs)
{
                int __lb0, __ub0;
                __lb0 = _LB_REPLACE_ME_DISTLOOG3t7;
                __ub0 = _UB_REPLACE_ME_DISTLOOG3t7;
#ifdef __USE_BLOCK_CYCLIC
                    if (__is_block_cyclic[3])
                     return polyrt_one_dim_pi_block_cyclic(t7, __lb0, __ub0, nprocs, __BLOCK_CYCLIC_BLOCK_SIZE);
                    else
 #endif
                    return polyrt_one_dim_pi(t7, __lb0, __ub0, nprocs);
}
int pi_threads_3( int t1, int t5, int t7, int N, int n, int my_rank, int nprocs, int num_threads)
{
int lbp, ubp;
                    polyrt_multi_dim_loop_dist(_LB_REPLACE_ME_DISTLOOG3t7, _UB_REPLACE_ME_DISTLOOG3t7, nprocs, my_rank, 1, 0, &lbp, &ubp);
                    int __lb0, __ub0;
                    __lb0 = lbp;
                    __ub0 = ubp;
                        return polyrt_one_dim_pi(t7, __lb0, __ub0, num_threads);
}
