#include "polyrt.h"
#include "buffer_manager.h"
#include "gemver.dist_dynsched_data_dist.h"
#include <stdio.h>
#include <math.h>
#include <assert.h>
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))







int is_receiver_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_1(1, ts2, ts3,N,n, nprocs) == my_rank) return 1;;
  if (pi_3(3, ts2, ts3,N,n, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */



return 0;
}

int get_num_remote_dep_tasks_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_1(1, ts2, ts3,N,n, nprocs) != my_rank) count++;;
  if (pi_3(3, ts2, ts3,N,n, nprocs) != my_rank) count++;;
}
/* End of CLooG code */



return count;
}

void remote_update_dep_tasks_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_1(1, ts2, ts3,N,n, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop1[(ts2-lb_tasks_loop1_dim0)*max_num_tasks_loop1_dim1+(ts3-lb_tasks_loop1_dim1)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_1(1, ts2, ts3,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_1(1, ts2, ts3,N,n,my_rank,nprocs); if (__is_multi_partitioned[1] || __is_block_cyclic[1]) affinity = -1; else affinity = pi_threads_1(1, ts2, ts3,N,n,my_rank,nprocs,num_threads); __Task task(1,1, ts2, ts3,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 1 task %d %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, ts3, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
  if (pi_3(3, ts2, ts3,N,n, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2-lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(ts3-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_3(3, ts2, ts3,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_3(3, ts2, ts3,N,n,my_rank,nprocs); if (__is_multi_partitioned[3] || __is_block_cyclic[3]) affinity = -1; else affinity = pi_threads_3(3, ts2, ts3,N,n,my_rank,nprocs,num_threads); __Task task(3,3, ts2, ts3,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2, ts3, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */


}

int get_num_local_dep_tasks_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_1(1, ts2, ts3,N,n, nprocs) == my_rank) count++;;
  if (pi_3(3, ts2, ts3,N,n, nprocs) == my_rank) count++;;
}
/* End of CLooG code */



return count;
}

void local_update_dep_tasks_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  
#pragma omp atomic capture
 captured_firing_count = --tasks_loop1[(ts2-lb_tasks_loop1_dim0)*max_num_tasks_loop1_dim1+(ts3-lb_tasks_loop1_dim1)+0]; if (captured_firing_count == 0) { if (pi_1(1, ts2, ts3,N,n, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_1(1, ts2, ts3,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_1(1, ts2, ts3,N,n,my_rank,nprocs); if (__is_multi_partitioned[1] || __is_block_cyclic[1]) affinity = -1; else affinity = pi_threads_1(1, ts2, ts3,N,n,my_rank,nprocs,num_threads); __Task task(1,1, ts2, ts3,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 1 task %d %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, ts3, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
  
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2-lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(ts3-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { if (pi_3(3, ts2, ts3,N,n, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_3(3, ts2, ts3,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_3(3, ts2, ts3,N,n,my_rank,nprocs); if (__is_multi_partitioned[3] || __is_block_cyclic[3]) affinity = -1; else affinity = pi_threads_3(3, ts2, ts3,N,n,my_rank,nprocs,num_threads); __Task task(3,3, ts2, ts3,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2, ts3, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */


}

int get_num_remote_src_tasks_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int get_num_local_src_tasks_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int is_receiver_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts3 <= floord(n-129,128)) {
    if (pi_1(1, ts2, ts3+1,N,n, nprocs) == my_rank) return 1;;
  }
  if (ts3 >= ceild(n-128,128)) {
    if (pi_2(2, ts2,N,n, nprocs) == my_rank) return 1;;
  }
}
/* End of CLooG code */



return 0;
}

int get_num_remote_dep_tasks_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts3 <= floord(n-129,128)) {
    if (pi_1(1, ts2, ts3+1,N,n, nprocs) != my_rank) count++;;
  }
  if (ts3 >= ceild(n-128,128)) {
    if (pi_2(2, ts2,N,n, nprocs) != my_rank) count++;;
  }
}
/* End of CLooG code */



return count;
}

void remote_update_dep_tasks_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts3 <= floord(n-129,128)) {
    if (pi_1(1, ts2, ts3+1,N,n, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop1[(ts2-lb_tasks_loop1_dim0)*max_num_tasks_loop1_dim1+(ts3+1 -lb_tasks_loop1_dim1)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_1(1, ts2, ts3+1,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_1(1, ts2, ts3+1,N,n,my_rank,nprocs); if (__is_multi_partitioned[1] || __is_block_cyclic[1]) affinity = -1; else affinity = pi_threads_1(1, ts2, ts3+1,N,n,my_rank,nprocs,num_threads); __Task task(1,1, ts2, ts3+1,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 1 task %d %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, ts3+1, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
  }
  if (ts3 >= ceild(n-128,128)) {
    if (pi_2(2, ts2,N,n, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2-lb_tasks_loop2_dim0)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_2(2, ts2,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_2(2, ts2,N,n,my_rank,nprocs); if (__is_multi_partitioned[2] || __is_block_cyclic[2]) affinity = -1; else affinity = pi_threads_2(2, ts2,N,n,my_rank,nprocs,num_threads); __Task task(2,2, ts2,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
  }
}
/* End of CLooG code */


}

int get_num_local_dep_tasks_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts3 <= floord(n-129,128)) {
    if (pi_1(1, ts2, ts3+1,N,n, nprocs) == my_rank) count++;;
  }
  if (ts3 >= ceild(n-128,128)) {
    if (pi_2(2, ts2,N,n, nprocs) == my_rank) count++;;
  }
}
/* End of CLooG code */



return count;
}

void local_update_dep_tasks_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts3 <= floord(n-129,128)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop1[(ts2-lb_tasks_loop1_dim0)*max_num_tasks_loop1_dim1+(ts3+1 -lb_tasks_loop1_dim1)+0]; if (captured_firing_count == 0) { if (pi_1(1, ts2, ts3+1,N,n, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_1(1, ts2, ts3+1,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_1(1, ts2, ts3+1,N,n,my_rank,nprocs); if (__is_multi_partitioned[1] || __is_block_cyclic[1]) affinity = -1; else affinity = pi_threads_1(1, ts2, ts3+1,N,n,my_rank,nprocs,num_threads); __Task task(1,1, ts2, ts3+1,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 1 task %d %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, ts3+1, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
  }
  if (ts3 >= ceild(n-128,128)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2-lb_tasks_loop2_dim0)+0]; if (captured_firing_count == 0) { if (pi_2(2, ts2,N,n, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_2(2, ts2,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_2(2, ts2,N,n,my_rank,nprocs); if (__is_multi_partitioned[2] || __is_block_cyclic[2]) affinity = -1; else affinity = pi_threads_2(2, ts2,N,n,my_rank,nprocs,num_threads); __Task task(2,2, ts2,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
  }
}
/* End of CLooG code */


}

int get_num_remote_src_tasks_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts3 >= 1) {
    if (pi_1(1, ts2, ts3-1, N, n, nprocs) != my_rank) count++;;
  }
  if (pi_0(0, ts2, ts3, N, n, nprocs) != my_rank) count++;;
}
/* End of CLooG code */



return count;
}

int get_num_local_src_tasks_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts3 >= 1) {
    if (pi_1(1, ts2, ts3-1, N, n, nprocs) == my_rank) count++;;
  }
  if (pi_0(0, ts2, ts3, N, n, nprocs) == my_rank) count++;;
}
/* End of CLooG code */



return count;
}

int is_receiver_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  for (t4=0;t4<=floord(n-1,128);t4++) {
    if (pi_3(3, ts2, t4,N,n, nprocs) == my_rank) return 1;;
  }
}
/* End of CLooG code */


return 0;
}

int get_num_remote_dep_tasks_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  for (t4=0;t4<=floord(n-1,128);t4++) {
    if (pi_3(3, ts2, t4,N,n, nprocs) != my_rank) count++;;
  }
}
/* End of CLooG code */


return count;
}

void remote_update_dep_tasks_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  for (t4=0;t4<=floord(n-1,128);t4++) {
    if (pi_3(3, ts2, t4,N,n, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2-lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(t4-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_3(3, ts2, t4,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_3(3, ts2, t4,N,n,my_rank,nprocs); if (__is_multi_partitioned[3] || __is_block_cyclic[3]) affinity = -1; else affinity = pi_threads_3(3, ts2, t4,N,n,my_rank,nprocs,num_threads); __Task task(3,3, ts2, t4,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2, t4, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
  }
}
/* End of CLooG code */

}

int get_num_local_dep_tasks_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  for (t4=0;t4<=floord(n-1,128);t4++) {
    if (pi_3(3, ts2, t4,N,n, nprocs) == my_rank) count++;;
  }
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  for (t4=0;t4<=floord(n-1,128);t4++) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2-lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(t4-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { if (pi_3(3, ts2, t4,N,n, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_3(3, ts2, t4,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_3(3, ts2, t4,N,n,my_rank,nprocs); if (__is_multi_partitioned[3] || __is_block_cyclic[3]) affinity = -1; else affinity = pi_threads_3(3, ts2, t4,N,n,my_rank,nprocs,num_threads); __Task task(3,3, ts2, t4,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2, t4, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
  }
}
/* End of CLooG code */

}

int get_num_remote_src_tasks_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  t4 = floord(n-1,128);
  if (pi_1(1, ts2, t4, N, n, nprocs) != my_rank) count++;;
}
/* End of CLooG code */


return count;
}

int get_num_local_src_tasks_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  t4 = floord(n-1,128);
  if (pi_1(1, ts2, t4, N, n, nprocs) == my_rank) count++;;
}
/* End of CLooG code */


return count;
}

int is_receiver_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-129) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_3(3, ts2+1, ts3,N,n, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

int get_num_remote_dep_tasks_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-129) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_3(3, ts2+1, ts3,N,n, nprocs) != my_rank) count++;;
}
/* End of CLooG code */


return count;
}

void remote_update_dep_tasks_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-129) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_3(3, ts2+1, ts3,N,n, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2+1 -lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(ts3-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_3(3, ts2+1, ts3,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_3(3, ts2+1, ts3,N,n,my_rank,nprocs); if (__is_multi_partitioned[3] || __is_block_cyclic[3]) affinity = -1; else affinity = pi_threads_3(3, ts2+1, ts3,N,n,my_rank,nprocs,num_threads); __Task task(3,3, ts2+1, ts3,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2+1, ts3, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */

}

int get_num_local_dep_tasks_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-129) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_3(3, ts2+1, ts3,N,n, nprocs) == my_rank) count++;;
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-129) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2+1 -lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(ts3-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { if (pi_3(3, ts2+1, ts3,N,n, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_3(3, ts2+1, ts3,N,n,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_3(3, ts2+1, ts3,N,n,my_rank,nprocs); if (__is_multi_partitioned[3] || __is_block_cyclic[3]) affinity = -1; else affinity = pi_threads_3(3, ts2+1, ts3,N,n,my_rank,nprocs,num_threads); __Task task(3,3, ts2+1, ts3,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2+1, ts3, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */

}

int get_num_remote_src_tasks_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;




  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts2 >= 1) {
    if (pi_3(3, ts2-1, ts3, N, n, nprocs) != my_rank) count++;;
  }
  if (pi_0(0, ts2, ts3, N, n, nprocs) != my_rank) count++;;
  if (pi_2(2, ts2, N, n, nprocs) != my_rank) count++;;
}
/* End of CLooG code */




return count;
}

int get_num_local_src_tasks_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

int count = 0;




  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts2 >= 1) {
    if (pi_3(3, ts2-1, ts3, N, n, nprocs) == my_rank) count++;;
  }
  if (pi_0(0, ts2, ts3, N, n, nprocs) == my_rank) count++;;
  if (pi_2(2, ts2, N, n, nprocs) == my_rank) count++;;
}
/* End of CLooG code */




return count;
}

int is_receiver_A_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_A_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_A_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_u1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_u1_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_u1_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_v1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_v1_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_v1_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_u2_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_u2_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_u2_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_v2_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_v2_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_v2_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_B_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_1(1, ts2, ts3, N, n, nprocs) == my_rank) return 1;;
  if (pi_3(3, ts2, ts3, N, n, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */



return 0;
}

void sigma_B_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 0) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  __p = pi_1(1, ts2, ts3, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
  __p = pi_3(3, ts2, ts3, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
}
/* End of CLooG code */


}

int is_receiver_B_1_0(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 0) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_1(1, ts2, ts3, N, n, nprocs) == my_rank) return 1;;
  if (pi_3(3, ts2, ts3, N, n, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */



return 0;
}

int is_receiver_x_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= n-1) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (ts3 <= floord(n-129,128)) {
    if (pi_1(1, ts2, ts3+1, N, n, nprocs) == my_rank) return 1;;
  }
  if (ts3 >= ceild(n-128,128)) {
    if (pi_2(2, ts2, N, n, nprocs) == my_rank) return 1;;
  }
}
/* End of CLooG code */



return 0;
}

void sigma_x_1_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 1) && (ts2 >= ts3+1) && (128*ts2 <= n-1) && (ts3 >= 0)) {
  __p = pi_1(1, ts2, ts3+1, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
}
/* End of CLooG code */

}

int is_receiver_x_1_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 1) && (ts2 >= ts3+1) && (128*ts2 <= n-1) && (ts3 >= 0)) {
  if (pi_1(1, ts2, ts3+1, N, n, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

void sigma_x_2_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 1) && (ts2 >= 0) && (ts2 == ts3) && (128*ts2 <= n-1)) {
  if (ts2 <= floord(n-129,128)) {
    __p = pi_1(1, ts2, ts2+1, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
  }
  if (ts2 >= ceild(n-128,128)) {
    __p = pi_2(2, ts2, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
  }
}
/* End of CLooG code */


}

int is_receiver_x_2_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 1) && (ts2 >= 0) && (ts2 == ts3) && (128*ts2 <= n-1)) {
  if (ts2 <= floord(n-129,128)) {
    if (pi_1(1, ts2, ts2+1, N, n, nprocs) == my_rank) return 1;;
  }
  if (ts2 >= ceild(n-128,128)) {
    if (pi_2(2, ts2, N, n, nprocs) == my_rank) return 1;;
  }
}
/* End of CLooG code */



return 0;
}

void sigma_x_3_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 1) && (ts2 >= 0) && (ts2 <= ts3-1) && (128*ts3 <= n-1)) {
  if (ts3 <= floord(n-129,128)) {
    __p = pi_1(1, ts2, ts3+1, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
  }
  if (ts3 >= ceild(n-128,128)) {
    __p = pi_2(2, ts2, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
  }
}
/* End of CLooG code */


}

int is_receiver_x_3_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{



  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 1) && (ts2 >= 0) && (ts2 <= ts3-1) && (128*ts3 <= n-1)) {
  if (ts3 <= floord(n-129,128)) {
    if (pi_1(1, ts2, ts3+1, N, n, nprocs) == my_rank) return 1;;
  }
  if (ts3 >= ceild(n-128,128)) {
    if (pi_2(2, ts2, N, n, nprocs) == my_rank) return 1;;
  }
}
/* End of CLooG code */



return 0;
}

int is_receiver_B_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_B_1_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_B_1_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_y_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_y_1_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_y_1_1(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_x_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  for (t4=0;t4<=floord(n-1,128);t4++) {
    if (pi_3(3, ts2, t4, N, n, nprocs) == my_rank) return 1;;
  }
}
/* End of CLooG code */


return 0;
}

void sigma_x_1_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  for (t4=0;t4<=floord(n-1,128);t4++) {
    __p = pi_3(3, ts2, t4, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
  }
}
/* End of CLooG code */

}

int is_receiver_x_1_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 2) && (ts2 >= 0) && (128*ts2 <= n-1)) {
  for (t4=0;t4<=floord(n-1,128);t4++) {
    if (pi_3(3, ts2, t4, N, n, nprocs) == my_rank) return 1;;
  }
}
/* End of CLooG code */


return 0;
}

int is_receiver_z_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_z_1_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_z_1_2(int ts1, int ts2, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_w_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-129) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_3(3, ts2+1, ts3, N, n, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

void sigma_w_1_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-129) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  __p = pi_3(3, ts2+1, ts3, N, n,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
}
/* End of CLooG code */

}

int is_receiver_w_1_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{


  int t1, t2, t3, t4;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((N >= 1) && (ts1 == 3) && (ts2 >= 0) && (128*ts2 <= n-129) && (ts3 >= 0) && (128*ts3 <= n-1)) {
  if (pi_3(3, ts2+1, ts3, N, n, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

int is_receiver_B_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_B_1_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_B_1_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int is_receiver_x_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_x_1_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_x_1_3(int ts1, int ts2, int ts3, int N, int n, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}
