
#include <mkl_scalapack.h>
#include <mpi.h>

typedef MKL_INT MDESC[ 9 ];
#define MAX(x,y) ((x) >(y)? (x) :(y))
/* Parameters */
const double  zero = 0.0E+0, one = 1.0E+0, two = 2.0E+0, oneeighty = 180.0E+0;
const MKL_INT i_zero = 0, i_one = 1, i_two = 2, i_four = 4, i_negone = -1;
const char    trans_N = 'N';
const char    trans_T = 'T';


void get_procs_grid_size(int p, int *nprow, int *npcol ){

    //printf("p in %d\n", p);
    switch(p) {
        case 1:
            *nprow = 1; *npcol = 1;
            return;
        case 2:
            *nprow = 2; *npcol = 1;
            return;
        case 3:
            *nprow = 3; *npcol = 1;
            return;
        case 4:
            *nprow = 2; *npcol = 2;
            return;
        case 5:
            *nprow = 5; *npcol = 1;
            return;
        case 6:
            *nprow = 3; *npcol = 2;
            return;
        case 7:
            *nprow = 7; *npcol = 1;
            return;
        case 8:
            *nprow = 4; *npcol = 2;
            return;
        case 9:
            *nprow = 3; *npcol = 3;
            return;
        case 10:
            *nprow = 5; *npcol = 2;
            return;
        case 16:
            *nprow = 4; *npcol = 4;
            return;
        case 25:
            *nprow = 5; *npcol = 5;
            return;
        case 32:
            *nprow = 8; *npcol = 4;
            return;
        default:
            *nprow = 1; *npcol = 1;
            return;
    }
}

void generate_random_values(double *arr, int size){

    if(arr == NULL) return;
    int i = 0;
    srand(rand());
    for(i =0; i<size; i++)
        arr[i] = rand()% 100;

    return;
}



