#include "polyrt.h"
#include "gesummv.dist_dynsched.h"
#include <stdio.h>
#include <math.h>
#include <assert.h>
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))







int is_receiver_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_1(1, ts2,_PB_N, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */



return 0;
}

int get_num_remote_dep_tasks_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_1(1, ts2,_PB_N, nprocs) != my_rank) count++;;
}
/* End of CLooG code */



return count;
}

void remote_update_dep_tasks_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_1(1, ts2,_PB_N, nprocs) == my_rank) { 
#pragma omp atomic capture
 captured_firing_count = --tasks_loop1[(ts2-lb_tasks_loop1_dim0)+0]; if (captured_firing_count == 0) { remote_dep_tasks = get_num_remote_dep_tasks_1(1, ts2,_PB_N,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_1(1, ts2,_PB_N,my_rank,nprocs); if (__is_multi_partitioned[1] || __is_block_cyclic[1]) affinity = -1; else affinity = pi_threads_1(1, ts2,_PB_N,my_rank,nprocs,num_threads); __Task task(1,1, ts2,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 1 task %d %d                     remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */


}

int get_num_local_dep_tasks_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

int count = 0;



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_1(1, ts2,_PB_N, nprocs) == my_rank) count++;;
}
/* End of CLooG code */



return count;
}

void local_update_dep_tasks_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  
#pragma omp atomic capture
 captured_firing_count = --tasks_loop1[(ts2-lb_tasks_loop1_dim0)+0]; if (captured_firing_count == 0) { if (pi_1(1, ts2,_PB_N, nprocs) == my_rank) { remote_dep_tasks = get_num_remote_dep_tasks_1(1, ts2,_PB_N,my_rank,nprocs); local_dep_tasks = get_num_local_dep_tasks_1(1, ts2,_PB_N,my_rank,nprocs); if (__is_multi_partitioned[1] || __is_block_cyclic[1]) affinity = -1; else affinity = pi_threads_1(1, ts2,_PB_N,my_rank,nprocs,num_threads); __Task task(1,1, ts2,remote_dep_tasks,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 1 task %d %d                             remote_dep_tasks %d local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, remote_dep_tasks, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); } };
}
/* End of CLooG code */


}

int get_num_remote_src_tasks_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return count;
}

int get_num_local_src_tasks_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */


return count;
}

int is_receiver_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

int get_num_remote_dep_tasks_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

int count = 0;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

void remote_update_dep_tasks_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int get_num_local_dep_tasks_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

int count = 0;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

void local_update_dep_tasks_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs, int num_threads,int *tasks_loop0,int *tasks_loop1)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int get_num_remote_src_tasks_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_0(0, ts2, _PB_N, nprocs) != my_rank) count++;;
}
/* End of CLooG code */


return count;
}

int get_num_local_src_tasks_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

int count = 0;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 1) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_0(0, ts2, _PB_N, nprocs) == my_rank) count++;;
}
/* End of CLooG code */


return count;
}

int is_receiver_tmp_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_1(1, ts2, _PB_N, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */



return 0;
}

void sigma_tmp_1_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs, int *receiver_list)
{
int __p;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  __p = pi_1(1, ts2, _PB_N,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
}
/* End of CLooG code */

}

int is_receiver_tmp_1_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_1(1, ts2, _PB_N, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

int is_receiver_y_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{



  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_1(1, ts2, _PB_N, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */



return 0;
}

void sigma_y_1_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs, int *receiver_list)
{
int __p;


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  __p = pi_1(1, ts2, _PB_N,nprocs); if (__p != my_rank) { receiver_list[__p] = 1; };
}
/* End of CLooG code */

}

int is_receiver_y_1_0(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{


  int t1, t2, t3;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (128*ts2 <= _PB_N-1)) {
  if (pi_1(1, ts2, _PB_N, nprocs) == my_rank) return 1;;
}
/* End of CLooG code */


return 0;
}

int is_receiver_y_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}

void sigma_y_1_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs, int *receiver_list)
{
int __p;

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */
}

int is_receiver_y_1_1(int ts1, int ts2, int _PB_N, int my_rank, int nprocs)
{

  int t1;

 int lb, ub, lbp, ubp, lbd, ubd, lb2, ub2;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return 0;
}
