#include "polyrt.h"
#include "buffer_manager.h"
void data_tile_ref_count_init_E_0(int ts1,int ts2, double** E_trans,int E_size_1, BufferManager *buff_mang_E);
void data_tile_ref_count_init_F_1(int ts1,int ts2, double** F_trans,int F_size_1, BufferManager *buff_mang_F);
void data_tile_ref_count_init_G_1(int ts1,int ts2, double** G_trans,int G_size_1, BufferManager *buff_mang_G);
void data_tile_ref_count_init_F_2(int ts1,int ts2, double** F_trans,int F_size_1, BufferManager *buff_mang_F);
void data_tile_ref_count_init_C_2(int ts1,int ts2, double** C_trans,int C_size_1, BufferManager *buff_mang_C);
void data_tile_ref_count_init_D_2(int ts1,int ts2, double** D_trans,int D_size_1, BufferManager *buff_mang_D);
void read_in_data_tile_alloc_F_2(int ts1,int ts2, double** F_trans,int F_size_1, BufferManager *buff_mang_F);
void read_in_data_tile_alloc_C_2(int ts1,int ts2, double** C_trans,int C_size_1, BufferManager *buff_mang_C);
void read_in_data_tile_alloc_D_2(int ts1,int ts2, double** D_trans,int D_size_1, BufferManager *buff_mang_D);
void data_tile_ref_count_init_E_3(int ts1,int ts2,int ts3, double** E_trans,int E_size_1, BufferManager *buff_mang_E);
void data_tile_ref_count_init_A_3(int ts1,int ts2,int ts3, double** A_trans,int A_size_1, BufferManager *buff_mang_A);
void data_tile_ref_count_init_B_3(int ts1,int ts2,int ts3, double** B_trans,int B_size_1, BufferManager *buff_mang_B);
void data_tile_ref_count_init_G_3(int ts1,int ts2,int ts3, double** G_trans,int G_size_1, BufferManager *buff_mang_G);
void data_tile_ref_count_init_F_3(int ts1,int ts2,int ts3, double** F_trans,int F_size_1, BufferManager *buff_mang_F);
void read_in_data_tile_alloc_E_3(int ts1,int ts2,int ts3, double** E_trans,int E_size_1, BufferManager *buff_mang_E);
void read_in_data_tile_alloc_A_3(int ts1,int ts2,int ts3, double** A_trans,int A_size_1, BufferManager *buff_mang_A);
void read_in_data_tile_alloc_B_3(int ts1,int ts2,int ts3, double** B_trans,int B_size_1, BufferManager *buff_mang_B);
void read_in_data_tile_alloc_G_3(int ts1,int ts2,int ts3, double** G_trans,int G_size_1, BufferManager *buff_mang_G);
void read_in_data_tile_alloc_F_3(int ts1,int ts2,int ts3, double** F_trans,int F_size_1, BufferManager *buff_mang_F);
#include "tbb/concurrent_priority_queue.h"

#include <omp.h>

#ifdef __DEBUG_FLUSH
#define IF_DEBUG_FLUSH(foo) foo
#else
#define IF_DEBUG_FLUSH(foo) 
#endif

#ifdef __DYNSCHEDULER_MORE_DEBUG_PRINT
#define IF_DYNSCHEDULER_MORE_DEBUG_PRINT(foo) foo
#else
#define IF_DYNSCHEDULER_MORE_DEBUG_PRINT(foo) 
#endif

#ifdef __DYNSCHEDULER_DEBUG_PRINT
#define IF_DYNSCHEDULER_DEBUG_PRINT(foo) foo
#else
#define IF_DYNSCHEDULER_DEBUG_PRINT(foo) 
#endif

extern FILE *__debug_print_fp;

class __Task {
	public:
		int loop;
		int id1;
		int id2;
		int id3;
		int local_dep_tasks;
		int thread_affinity;
		__Task() {}
		__Task(const int l, const int _id1, const int _id2, const int local, const int affinity) :
			loop(l),
			id1(_id1),
			id2(_id2),
			id3(0),
			local_dep_tasks(local),
			thread_affinity(affinity) {}
		__Task(const int l, const int _id1, const int _id2, const int _id3, const int local, const int affinity) :
			loop(l),
			id1(_id1),
			id2(_id2),
			id3(_id3),
			local_dep_tasks(local),
			thread_affinity(affinity) {}
		__Task(const __Task &task) :
			loop(task.loop),
			id1(task.id1),
			id2(task.id2),
			id3(task.id3),
			local_dep_tasks(task.local_dep_tasks),
			thread_affinity(task.thread_affinity) {}
		~__Task() {}
};

class __Compare {
	public:
		// returns true only if task2 has higher priority than task1
		bool operator()(const __Task &task1, const __Task &task2) const {
#ifndef __DYNSCHEDULER_NO_PRIORITY
			if (task2.local_dep_tasks>task1.local_dep_tasks) return true;
			if (task1.local_dep_tasks>task2.local_dep_tasks) return false;
			int thread_id = omp_get_thread_num();
			if ((thread_id == task2.thread_affinity) && (thread_id != task1.thread_affinity)) return true;
			if ((thread_id == task1.thread_affinity) && (thread_id != task2.thread_affinity)) return false;
			// lexicographic compare 
			if ( (task2.id1 > task1.id1) 
				|| ( (task2.id1 == task1.id1) && (task2.id2 > task1.id2) ) 
				|| ( (task2.id1 == task1.id1) && (task2.id2 == task1.id2) && (task2.id3 > task1.id3) ) )
				 return true;
#endif
			return false;
		}
};

extern tbb::concurrent_priority_queue<__Task, __Compare> pqueue;

int get_num_local_dep_tasks_0(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM);
void local_update_dep_tasks_0(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3);
int get_num_local_src_tasks_0(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM);
extern int max_num_tasks_loop0_dim0;
extern int lb_tasks_loop0_dim0;
extern int *tasks_loop0;
int get_num_local_dep_tasks_1(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM);
void local_update_dep_tasks_1(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3);
int get_num_local_src_tasks_1(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM);
extern int max_num_tasks_loop1_dim0;
extern int lb_tasks_loop1_dim0;
extern int *tasks_loop1;
int get_num_local_dep_tasks_2(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM);
void local_update_dep_tasks_2(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3);
int get_num_local_src_tasks_2(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM);
extern int max_num_tasks_loop2_dim0;
extern int lb_tasks_loop2_dim0;
extern int *tasks_loop2;
int get_num_local_dep_tasks_3(int ts1, int ts2, int ts3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM);
void local_update_dep_tasks_3(int ts1, int ts2, int ts3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3);
int get_num_local_src_tasks_3(int ts1, int ts2, int ts3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM);
extern int max_num_tasks_loop3_dim0;
extern int lb_tasks_loop3_dim0;
extern int max_num_tasks_loop3_dim1;
extern int lb_tasks_loop3_dim1;
extern int *tasks_loop3;
void init_tasks(int num_threads,long int *p_num_tasks_to_execute,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3);
int pi_0( int t2, int t3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int nprocs);
int pi_1( int t2, int t3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int nprocs);
int pi_2( int t2, int t3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int nprocs);
int pi_3( int t2, int t3, int t4, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int nprocs);
void data_tile_alloc_0(int ts1,int ts2, double** E_trans,int E_size_1, BufferManager *buff_mang_E);
void data_tile_ref_count_update_0(int ts1,int ts2, double** E_trans,int E_size_1, BufferManager *buff_mang_E);
void compute_task_0(int t1,int t2, double** E_trans,int E_size_1, BufferManager *buff_mang_E);
void data_tile_alloc_1(int ts1,int ts2, double** F_trans,int F_size_1, BufferManager *buff_mang_F, double** G_trans,int G_size_1, BufferManager *buff_mang_G);
void data_tile_ref_count_update_1(int ts1,int ts2, double** F_trans,int F_size_1, BufferManager *buff_mang_F, double** G_trans,int G_size_1, BufferManager *buff_mang_G);
void compute_task_1(int t1,int t2, double** F_trans,int F_size_1, BufferManager *buff_mang_F, double** G_trans,int G_size_1, BufferManager *buff_mang_G);
void data_tile_alloc_2(int ts1,int ts2, double** F_trans,int F_size_1, BufferManager *buff_mang_F, double** C_trans,int C_size_1, BufferManager *buff_mang_C, double** D_trans,int D_size_1, BufferManager *buff_mang_D);
void data_tile_ref_count_update_2(int ts1,int ts2, double** F_trans,int F_size_1, BufferManager *buff_mang_F, double** C_trans,int C_size_1, BufferManager *buff_mang_C, double** D_trans,int D_size_1, BufferManager *buff_mang_D);
void compute_task_2(int t1,int t2, double** F_trans,int F_size_1, BufferManager *buff_mang_F, double** C_trans,int C_size_1, BufferManager *buff_mang_C, double** D_trans,int D_size_1, BufferManager *buff_mang_D);
void data_tile_alloc_3(int ts1,int ts2,int ts3, double** E_trans,int E_size_1, BufferManager *buff_mang_E, double** A_trans,int A_size_1, BufferManager *buff_mang_A, double** B_trans,int B_size_1, BufferManager *buff_mang_B, double** G_trans,int G_size_1, BufferManager *buff_mang_G, double** F_trans,int F_size_1, BufferManager *buff_mang_F);
void data_tile_ref_count_update_3(int ts1,int ts2,int ts3, double** E_trans,int E_size_1, BufferManager *buff_mang_E, double** A_trans,int A_size_1, BufferManager *buff_mang_A, double** B_trans,int B_size_1, BufferManager *buff_mang_B, double** G_trans,int G_size_1, BufferManager *buff_mang_G, double** F_trans,int F_size_1, BufferManager *buff_mang_F);
void compute_task_3(int t1,int t2,int t3, double** E_trans,int E_size_1, BufferManager *buff_mang_E, double** A_trans,int A_size_1, BufferManager *buff_mang_A, double** B_trans,int B_size_1, BufferManager *buff_mang_B, double** G_trans,int G_size_1, BufferManager *buff_mang_G, double** F_trans,int F_size_1, BufferManager *buff_mang_F);
