#include <math.h>
#include <assert.h>
#include "pi_defs.h"
#include "polyrt.h"
#include "buffer_manager.h"
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))

#ifndef __BLOCK_CYCLIC_BLOCK_SIZE
#define __BLOCK_CYCLIC_BLOCK_SIZE 1
#endif

int pi_0( int t2, int t3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int nprocs)
{
                int __lb0, __ub0;
                __lb0 = _LB_REPLACE_ME_DISTLOOG0t3;
                __ub0 = _UB_REPLACE_ME_DISTLOOG0t3;
#ifdef __USE_BLOCK_CYCLIC
                    if (__is_block_cyclic[0])
                     return polyrt_one_dim_pi_block_cyclic(t3, __lb0, __ub0, nprocs, __BLOCK_CYCLIC_BLOCK_SIZE);
                    else
 #endif
                    return polyrt_one_dim_pi(t3, __lb0, __ub0, nprocs);
}
int pi_1( int t2, int t3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int nprocs)
{
                int __lb0, __ub0;
                __lb0 = _LB_REPLACE_ME_DISTLOOG1t3;
                __ub0 = _UB_REPLACE_ME_DISTLOOG1t3;
#ifdef __USE_BLOCK_CYCLIC
                    if (__is_block_cyclic[1])
                     return polyrt_one_dim_pi_block_cyclic(t3, __lb0, __ub0, nprocs, __BLOCK_CYCLIC_BLOCK_SIZE);
                    else
 #endif
                    return polyrt_one_dim_pi(t3, __lb0, __ub0, nprocs);
}
int pi_2( int t2, int t3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int nprocs)
{
                int __lb0, __ub0;
                __lb0 = _LB_REPLACE_ME_DISTLOOG2t3;
                __ub0 = _UB_REPLACE_ME_DISTLOOG2t3;
#ifdef __USE_BLOCK_CYCLIC
                    if (__is_block_cyclic[2])
                     return polyrt_one_dim_pi_block_cyclic(t3, __lb0, __ub0, nprocs, __BLOCK_CYCLIC_BLOCK_SIZE);
                    else
 #endif
                    return polyrt_one_dim_pi(t3, __lb0, __ub0, nprocs);
}
int pi_3( int t2, int t3, int t4, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int nprocs)
{
                int __lb0, __ub0;
                __lb0 = _LB_REPLACE_ME_DISTLOOG3t4;
                __ub0 = _UB_REPLACE_ME_DISTLOOG3t4;
#ifdef __USE_BLOCK_CYCLIC
                    if (__is_block_cyclic[3])
                     return polyrt_one_dim_pi_block_cyclic(t4, __lb0, __ub0, nprocs, __BLOCK_CYCLIC_BLOCK_SIZE);
                    else
 #endif
                    return polyrt_one_dim_pi(t4, __lb0, __ub0, nprocs);
}
