#include "polyrt.h"
#include "buffer_manager.h"
#include "3mm.dyn_data_dist.h"
#include <stdio.h>
#include <math.h>
#include <assert.h>
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))





int get_num_local_dep_tasks_0(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM)
{

int count = 0;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NJ-1)) {
  for (t3=ts2;t3<=floord(32*ts2+_PB_NI-1,32);t3++) {
    count++;;
  }
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_0(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 2) && (ts2 >= 0) && (32*ts2 <= _PB_NJ-1)) {
  for (t3=ts2;t3<=floord(32*ts2+_PB_NI-1,32);t3++) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(t3-lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(t3-ts2-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_3(3, t3, t3-ts2,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM); affinity = pi_3(3, t3, t3-ts2,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM,num_threads); __Task task(3,3, t3, t3-ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 3, t3, t3-ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
}
/* End of CLooG code */

}

int get_num_local_src_tasks_0(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM)
{

int count = 0;

  int t1;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int get_num_local_dep_tasks_1(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM)
{

int count = 0;



  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NJ >= 1) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 0) && (ts2 >= 0)) {
  if (ts2 <= floord(_PB_NI-1,32)) {
    count++;;
  }
  if (ts2 <= floord(_PB_NJ-1,32)) {
    count++;;
  }
}
/* End of CLooG code */



return count;
}

void local_update_dep_tasks_1(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;



  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NJ >= 1) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 0) && (ts2 >= 0)) {
  if (ts2 <= floord(_PB_NI-1,32)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2-lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(ts2-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_3(3, ts2, ts2,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM); affinity = pi_3(3, ts2, ts2,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM,num_threads); __Task task(3,3, ts2, ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2, ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
  if (ts2 <= floord(_PB_NJ-1,32)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2-lb_tasks_loop2_dim0)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(1, ts2,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM); affinity = pi_2(1, ts2,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM,num_threads); __Task task(2,1, ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 1, ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
}
/* End of CLooG code */


}

int get_num_local_src_tasks_1(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM)
{

int count = 0;

  int t1;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int get_num_local_dep_tasks_2(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM)
{

int count = 0;



  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 1) && (ts2 >= 0) && (32*ts2 <= _PB_NJ-1)) {
  for (t3=ts2;t3<=floord(32*ts2+_PB_NI-1,32);t3++) {
    count++;;
  }
}
/* End of CLooG code */



return count;
}

void local_update_dep_tasks_2(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;



  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 1) && (ts2 >= 0) && (32*ts2 <= _PB_NJ-1)) {
  for (t3=ts2;t3<=floord(32*ts2+_PB_NI-1,32);t3++) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(t3-lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(t3-ts2-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_3(3, t3, t3-ts2,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM); affinity = pi_3(3, t3, t3-ts2,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM,num_threads); __Task task(3,3, t3, t3-ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 3, t3, t3-ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
}
/* End of CLooG code */


}

int get_num_local_src_tasks_2(int ts1, int ts2, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM)
{

int count = 0;



  int t1, t2, t3;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 1) && (ts2 >= 0) && (32*ts2 <= _PB_NJ-1)) {
  count++;;
}
/* End of CLooG code */



return count;
}

int get_num_local_dep_tasks_3(int ts1, int ts2, int ts3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM)
{

int count = 0;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NJ >= 2) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 3) && (ts2 >= ts3) && (32*ts2 <= 32*ts3+_PB_NJ-33) && (ts3 >= 0) && (32*ts3 <= _PB_NI-1)) {
  count++;;
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_3(int ts1, int ts2, int ts3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2,int *tasks_loop3)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NI >= 1) && (_PB_NJ >= 2) && (_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 3) && (ts2 >= ts3) && (32*ts2 <= 32*ts3+_PB_NJ-33) && (ts3 >= 0) && (32*ts3 <= _PB_NI-1)) {
  
#pragma omp atomic capture
 captured_firing_count = --tasks_loop3[(ts2+1 -lb_tasks_loop3_dim0)*max_num_tasks_loop3_dim1+(ts3-lb_tasks_loop3_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_3(3, ts2+1, ts3,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM); affinity = pi_3(3, ts2+1, ts3,_PB_NI,_PB_NJ,_PB_NK,_PB_NL,_PB_NM,num_threads); __Task task(3,3, ts2+1, ts3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 3 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 3, ts2+1, ts3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
}
/* End of CLooG code */

}

int get_num_local_src_tasks_3(int ts1, int ts2, int ts3, int _PB_NI, int _PB_NJ, int _PB_NK, int _PB_NL, int _PB_NM)
{

int count = 0;





  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_NK >= 1) && (_PB_NL >= 1) && (_PB_NM >= 1) && (ts1 == 3) && (ts2 >= ts3) && (32*ts2 <= 32*ts3+_PB_NJ-1) && (ts3 >= 0) && (32*ts3 <= _PB_NI-1)) {
  count++;;
  if (ts2 >= ts3+1) {
    count++;;
  }
  if (ts2 == ts3) {
    count++;;
  }
  count++;;
}
/* End of CLooG code */





return count;
}
