#include "polyrt.h"
#include "cholesky.dyn.h"
#include <stdio.h>
#include <math.h>
#include <assert.h>
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))





int get_num_local_dep_tasks_0(int ts1, int ts2, int _PB_N)
{

int count = 0;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_N >= 2) && (ts1 == 1) && (ts2 >= 0) && (64*ts2 <= _PB_N-1)) {
  count++;;
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_0(int ts1, int ts2, int _PB_N, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_N >= 2) && (ts1 == 1) && (ts2 >= 0) && (64*ts2 <= _PB_N-1)) {
  
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2-lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+(ts2-lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, ts2, ts2,_PB_N); affinity = pi_2(2, ts2, ts2,_PB_N,num_threads); __Task task(2,2, ts2, ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2, ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
}
/* End of CLooG code */

}

int get_num_local_src_tasks_0(int ts1, int ts2, int _PB_N)
{

int count = 0;

  int t1;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int get_num_local_dep_tasks_1(int ts1, int ts2, int _PB_N)
{

int count = 0;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (64*ts2 <= _PB_N-2)) {
  for (t3=ts2;t3<=floord(_PB_N-1,64);t3++) {
    count++;;
  }
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_1(int ts1, int ts2, int _PB_N, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 0) && (ts2 >= 0) && (64*ts2 <= _PB_N-2)) {
  for (t3=ts2;t3<=floord(_PB_N-1,64);t3++) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(t3-lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+(t3-lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, t3, t3,_PB_N); affinity = pi_2(2, t3, t3,_PB_N,num_threads); __Task task(2,2, t3, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, t3, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
}
/* End of CLooG code */

}

int get_num_local_src_tasks_1(int ts1, int ts2, int _PB_N)
{

int count = 0;

  int t1;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
/* End of CLooG code */

return count;
}

int get_num_local_dep_tasks_2(int ts1, int ts2, int ts3, int _PB_N)
{

int count = 0;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= ts3) && (ts2 <= 2*ts3) && (64*ts2 <= 64*ts3+_PB_N-65) && (64*ts3 <= _PB_N-1)) {
  if ((ts2 <= 2*ts3-1) && (ts3 <= floord(_PB_N-129,64))) {
    for (t4=ts3;t4<=ts3+1;t4++) {
      if (t4 == ts3) {
        count++;;
      }
      if (t4 == ts3+1) {
        count++;;
      }
    }
    for (t3=ts2+2;t3<=floord(64*ts2-64*ts3+_PB_N-1,64);t3++) {
      count++;;
    }
  }
  if ((ts2 <= 2*ts3-1) && (ts3 >= ceild(_PB_N-128,64))) {
    for (t4=ts3;t4<=floord(_PB_N-1,64);t4++) {
      if (t4 == ts3) {
        count++;;
      }
      if (t4 == ts3+1) {
        count++;;
      }
    }
  }
  if ((ts2 == 2*ts3) && (ts2 <= floord(_PB_N-129,32))) {
    if (ts2%2 == 0) {
      count++;;
    }
    for (t3=ts2+2;t3<=floord(32*ts2+_PB_N-1,64);t3++) {
      if (ts2%2 == 0) {
        count++;;
      }
    }
  }
  if ((ts2 == 2*ts3) && (ts2 >= ceild(_PB_N-128,32))) {
    if (ts2%2 == 0) {
      count++;;
    }
  }
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_2(int ts1, int ts2, int ts3, int _PB_N, int num_threads,int *tasks_loop0,int *tasks_loop1,int *tasks_loop2)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 == 2) && (ts2 >= ts3) && (ts2 <= 2*ts3) && (64*ts2 <= 64*ts3+_PB_N-65) && (64*ts3 <= _PB_N-1)) {
  if ((ts2 <= 2*ts3-1) && (ts3 <= floord(_PB_N-129,64))) {
    for (t4=ts3;t4<=ts3+1;t4++) {
      if (t4 == ts3) {
        
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2+1 -lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+(ts3-lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, ts2+1, ts3,_PB_N); affinity = pi_2(2, ts2+1, ts3,_PB_N,num_threads); __Task task(2,2, ts2+1, ts3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2+1, ts3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
      }
      if (t4 == ts3+1) {
        
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2+1 -lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+(ts3+1 -lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, ts2+1, ts3+1,_PB_N); affinity = pi_2(2, ts2+1, ts3+1,_PB_N,num_threads); __Task task(2,2, ts2+1, ts3+1,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2+1, ts3+1, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
      }
    }
    for (t3=ts2+2;t3<=floord(64*ts2-64*ts3+_PB_N-1,64);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(t3-lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+(t3-ts2+ts3-lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, t3, t3-ts2+ts3,_PB_N); affinity = pi_2(2, t3, t3-ts2+ts3,_PB_N,num_threads); __Task task(2,2, t3, t3-ts2+ts3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, t3, t3-ts2+ts3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((ts2 <= 2*ts3-1) && (ts3 >= ceild(_PB_N-128,64))) {
    for (t4=ts3;t4<=floord(_PB_N-1,64);t4++) {
      if (t4 == ts3) {
        
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2+1 -lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+(ts3-lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, ts2+1, ts3,_PB_N); affinity = pi_2(2, ts2+1, ts3,_PB_N,num_threads); __Task task(2,2, ts2+1, ts3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2+1, ts3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
      }
      if (t4 == ts3+1) {
        
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2+1 -lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+(ts3+1 -lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, ts2+1, ts3+1,_PB_N); affinity = pi_2(2, ts2+1, ts3+1,_PB_N,num_threads); __Task task(2,2, ts2+1, ts3+1,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2+1, ts3+1, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
      }
    }
  }
  if ((ts2 == 2*ts3) && (ts2 <= floord(_PB_N-129,32))) {
    if (ts2%2 == 0) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2+1 -lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+((ts2+2)/2 -lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, ts2+1, (ts2+2)/2,_PB_N); affinity = pi_2(2, ts2+1, (ts2+2)/2,_PB_N,num_threads); __Task task(2,2, ts2+1, (ts2+2)/2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2+1, (ts2+2)/2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    for (t3=ts2+2;t3<=floord(32*ts2+_PB_N-1,64);t3++) {
      if (ts2%2 == 0) {
        
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(t3-lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+((2*t3-ts2)/2 -lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, t3, (2*t3-ts2)/2,_PB_N); affinity = pi_2(2, t3, (2*t3-ts2)/2,_PB_N,num_threads); __Task task(2,2, t3, (2*t3-ts2)/2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, t3, (2*t3-ts2)/2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
      }
    }
  }
  if ((ts2 == 2*ts3) && (ts2 >= ceild(_PB_N-128,32))) {
    if (ts2%2 == 0) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop2[(ts2+1 -lb_tasks_loop2_dim0)*max_num_tasks_loop2_dim1+((ts2+2)/2 -lb_tasks_loop2_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_2(2, ts2+1, (ts2+2)/2,_PB_N); affinity = pi_2(2, ts2+1, (ts2+2)/2,_PB_N,num_threads); __Task task(2,2, ts2+1, (ts2+2)/2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 2 task %d %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 2, ts2+1, (ts2+2)/2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
}
/* End of CLooG code */

}

int get_num_local_src_tasks_2(int ts1, int ts2, int ts3, int _PB_N)
{

int count = 0;




  int t1, t2, t3, t4;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_N >= 2) && (ts1 == 2) && (ts2 >= ts3) && (ts2 <= 2*ts3) && (64*ts3 <= _PB_N-1)) {
  if ((ts2 >= ts3+1) && (ts2 <= 2*ts3-2)) {
    for (t3=2*ts2-2*ts3;t3<=ts2-2;t3++) {
      count++;;
    }
    for (t4=ts3-1;t4<=ts3;t4++) {
      if (t4 == ts3) {
        count++;;
      }
      if (t4 == ts3-1) {
        count++;;
      }
    }
  }
  if ((ts2 >= 2) && (ts2 == ts3)) {
    for (t3=0;t3<=ts2-2;t3++) {
      count++;;
    }
    count++;;
  }
  if (ts2 >= max(ts3+1,2*ts3-1)) {
    for (t4=ts2-ts3;t4<=ts3;t4++) {
      if (t4 == ts3) {
        count++;;
      }
      if ((2*t4 == ts2-1) && (ts2 == 2*ts3-1)) {
        if ((ts2+1)%2 == 0) {
          count++;;
        }
      }
    }
  }
  if ((ts2 == 1) && (ts3 == 1)) {
    count++;;
  }
  if (ts2 == ts3) {
    for (t3=0;t3<=min(floord(_PB_N-2,64),ts2);t3++) {
      count++;;
    }
  }
  if (ts2 == ts3) {
    count++;;
  }
}
/* End of CLooG code */




return count;
}
