#include "polyrt.h"
#include "floyd-warshall.dyn.h"
#include <stdio.h>
#include <math.h>
#include <assert.h>
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))





int get_num_local_dep_tasks_0(int ts1, int ts2, int _PB_N)
{

int count = 0;


  int t1, t2, t3;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 >= 0) && (ts1 <= _PB_N-2) && (ts2 >= 0) && (32*ts2 <= _PB_N-1)) {
  if (ts1 <= 32*ts2-2) {
    t3 = floord(ts1,32);
    count++;;
    count++;;
  }
  if ((ts1 == 32*ts2+30) && (ts1 >= 62) && (ts1 <= _PB_N-3)) {
    for (t3=0;t3<=floord(ts1-62,32);t3++) {
      count++;;
    }
    if ((ts1+2)%32 == 0) {
      count++;;
    }
    for (t3=ceild(ts1+2,32);t3<=floord(_PB_N-1,32);t3++) {
      count++;;
    }
  }
  if ((ts1 == _PB_N-2) && (ts1 == 32*ts2+30) && (ts1 >= 62)) {
    for (t3=0;t3<=floord(ts1-62,32);t3++) {
      count++;;
    }
    if ((ts1+2)%32 == 0) {
      count++;;
    }
  }
  if ((ts1 == 32*ts2-1) && (ts1 >= 63) && (ts1 <= _PB_N-3)) {
    for (t3=0;t3<=floord(ts1-63,32);t3++) {
      count++;;
    }
    if ((ts1+1)%32 == 0) {
      count++;;
    }
    for (t3=ceild(ts1+1,32);t3<=floord(_PB_N-1,32);t3++) {
      count++;;
    }
  }
  if ((ts1 == _PB_N-2) && (ts1 == 32*ts2-1) && (ts1 >= 63)) {
    for (t3=0;t3<=floord(ts1-63,32);t3++) {
      count++;;
    }
    if ((ts1+1)%32 == 0) {
      count++;;
    }
    if ((ts1+1)%32 == 0) {
      count++;;
    }
  }
  if ((ts1 <= min(_PB_N-3,32*ts2+29)) && (ts1 >= max(32,32*ts2))) {
    for (t3=0;t3<=floord(ts1-32,32);t3++) {
      count++;;
    }
    for (t3=ceild(ts1-29,32);t3<=floord(_PB_N-1,32);t3++) {
      count++;;
    }
  }
  if ((ts1 == _PB_N-2) && (ts1 <= 32*ts2+29) && (ts1 >= max(32,32*ts2))) {
    for (t3=0;t3<=floord(ts1-32,32);t3++) {
      count++;;
    }
    count++;;
  }
  if ((ts1 <= _PB_N-3) && (ts1 >= max(32,32*ts2+31))) {
    count++;;
  }
  if ((_PB_N >= 33) && (ts1 == 30) && (ts2 == 0)) {
    count++;;
    for (t3=1;t3<=floord(_PB_N-1,32);t3++) {
      count++;;
    }
  }
  if ((_PB_N >= 34) && (ts1 == 31) && (ts2 == 0)) {
    count++;;
  }
  if ((_PB_N >= 34) && (ts1 == 31) && (ts2 == 1)) {
    count++;;
    for (t3=1;t3<=floord(_PB_N-1,32);t3++) {
      count++;;
    }
  }
  if ((_PB_N == 33) && (ts1 == 31) && (ts2 == 1)) {
    count++;;
    count++;;
  }
  if ((ts1 <= min(29,_PB_N-3)) && (ts2 == 0)) {
    for (t3=ceild(ts1-29,32);t3<=floord(_PB_N-1,32);t3++) {
      count++;;
    }
  }
  if ((ts1 == _PB_N-2) && (ts1 >= max(32,32*ts2+31))) {
    count++;;
  }
  if ((ts1 == _PB_N-2) && (ts1 <= 31) && (ts2 == 0)) {
    count++;;
  }
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_0(int ts1, int ts2, int _PB_N, int num_threads,int *tasks_loop0)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 >= 0) && (ts1 <= _PB_N-2) && (ts2 >= 0) && (32*ts2 <= _PB_N-1)) {
  if (ts1 <= 32*ts2-2) {
    t3 = floord(ts1,32);
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(ts2-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, ts2,_PB_N); affinity = pi_0(ts1+1, ts2,_PB_N,num_threads); __Task task(0,ts1+1, ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
  if ((ts1 == 32*ts2+30) && (ts1 >= 62) && (ts1 <= _PB_N-3)) {
    for (t3=0;t3<=floord(ts1-62,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    if ((ts1+2)%32 == 0) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+((ts1-30)/32 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, (ts1-30)/32,_PB_N); affinity = pi_0(ts1+1, (ts1-30)/32,_PB_N,num_threads); __Task task(0,ts1+1, (ts1-30)/32,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, (ts1-30)/32, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    for (t3=ceild(ts1+2,32);t3<=floord(_PB_N-1,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((ts1 == _PB_N-2) && (ts1 == 32*ts2+30) && (ts1 >= 62)) {
    for (t3=0;t3<=floord(ts1-62,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    if ((ts1+2)%32 == 0) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+((ts1-30)/32 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, (ts1-30)/32,_PB_N); affinity = pi_0(ts1+1, (ts1-30)/32,_PB_N,num_threads); __Task task(0,ts1+1, (ts1-30)/32,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, (ts1-30)/32, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((ts1 == 32*ts2-1) && (ts1 >= 63) && (ts1 <= _PB_N-3)) {
    for (t3=0;t3<=floord(ts1-63,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    if ((ts1+1)%32 == 0) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+((ts1-31)/32 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, (ts1-31)/32,_PB_N); affinity = pi_0(ts1+1, (ts1-31)/32,_PB_N,num_threads); __Task task(0,ts1+1, (ts1-31)/32,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, (ts1-31)/32, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    for (t3=ceild(ts1+1,32);t3<=floord(_PB_N-1,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((ts1 == _PB_N-2) && (ts1 == 32*ts2-1) && (ts1 >= 63)) {
    for (t3=0;t3<=floord(ts1-63,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    if ((ts1+1)%32 == 0) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+((ts1-31)/32 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, (ts1-31)/32,_PB_N); affinity = pi_0(ts1+1, (ts1-31)/32,_PB_N,num_threads); __Task task(0,ts1+1, (ts1-31)/32,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, (ts1-31)/32, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    if ((ts1+1)%32 == 0) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+((ts1+1)/32 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, (ts1+1)/32,_PB_N); affinity = pi_0(ts1+1, (ts1+1)/32,_PB_N,num_threads); __Task task(0,ts1+1, (ts1+1)/32,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, (ts1+1)/32, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((ts1 <= min(_PB_N-3,32*ts2+29)) && (ts1 >= max(32,32*ts2))) {
    for (t3=0;t3<=floord(ts1-32,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    for (t3=ceild(ts1-29,32);t3<=floord(_PB_N-1,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((ts1 == _PB_N-2) && (ts1 <= 32*ts2+29) && (ts1 >= max(32,32*ts2))) {
    for (t3=0;t3<=floord(ts1-32,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(ts2-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, ts2,_PB_N); affinity = pi_0(ts1+1, ts2,_PB_N,num_threads); __Task task(0,ts1+1, ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
  if ((ts1 <= _PB_N-3) && (ts1 >= max(32,32*ts2+31))) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(ts2-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, ts2,_PB_N); affinity = pi_0(ts1+1, ts2,_PB_N,num_threads); __Task task(0,ts1+1, ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
  if ((_PB_N >= 33) && (ts1 == 30) && (ts2 == 0)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(31 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(0 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(31, 0,_PB_N); affinity = pi_0(31, 0,_PB_N,num_threads); __Task task(0,31, 0,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 31, 0, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    for (t3=1;t3<=floord(_PB_N-1,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(31 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(31, t3,_PB_N); affinity = pi_0(31, t3,_PB_N,num_threads); __Task task(0,31, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 31, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((_PB_N >= 34) && (ts1 == 31) && (ts2 == 0)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(32 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(0 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(32, 0,_PB_N); affinity = pi_0(32, 0,_PB_N,num_threads); __Task task(0,32, 0,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 32, 0, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
  if ((_PB_N >= 34) && (ts1 == 31) && (ts2 == 1)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(32 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(0 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(32, 0,_PB_N); affinity = pi_0(32, 0,_PB_N,num_threads); __Task task(0,32, 0,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 32, 0, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    for (t3=1;t3<=floord(_PB_N-1,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(32 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(32, t3,_PB_N); affinity = pi_0(32, t3,_PB_N,num_threads); __Task task(0,32, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 32, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((_PB_N == 33) && (ts1 == 31) && (ts2 == 1)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(32 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(0 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(32, 0,_PB_N); affinity = pi_0(32, 0,_PB_N,num_threads); __Task task(0,32, 0,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 32, 0, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(32 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(1 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(32, 1,_PB_N); affinity = pi_0(32, 1,_PB_N,num_threads); __Task task(0,32, 1,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, 32, 1, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
  if ((ts1 <= min(29,_PB_N-3)) && (ts2 == 0)) {
    for (t3=ceild(ts1-29,32);t3<=floord(_PB_N-1,32);t3++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t3-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, t3,_PB_N); affinity = pi_0(ts1+1, t3,_PB_N,num_threads); __Task task(0,ts1+1, t3,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, t3, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
  if ((ts1 == _PB_N-2) && (ts1 >= max(32,32*ts2+31))) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(ts2-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, ts2,_PB_N); affinity = pi_0(ts1+1, ts2,_PB_N,num_threads); __Task task(0,ts1+1, ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
  if ((ts1 == _PB_N-2) && (ts1 <= 31) && (ts2 == 0)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(0 -lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, 0,_PB_N); affinity = pi_0(ts1+1, 0,_PB_N,num_threads); __Task task(0,ts1+1, 0,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, 0, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
}
/* End of CLooG code */

}

int get_num_local_src_tasks_0(int ts1, int ts2, int _PB_N)
{

int count = 0;


  int t1, t2, t3;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 >= 1) && (ts1 <= _PB_N-1) && (ts2 >= 0) && (32*ts2 <= _PB_N-1)) {
  if (ts1 <= 32*ts2-1) {
    t3 = floord(ts1,32);
    count++;;
    count++;;
  }
  if ((ts1 >= 32*ts2+1) && (ts1 <= 32*ts2+30) && (ts2 <= floord(_PB_N-33,32))) {
    count++;;
    for (t3=ts2+1;t3<=floord(_PB_N-1,32);t3++) {
      count++;;
    }
  }
  if ((ts1 <= _PB_N-2) && (ts1 >= 32*ts2+1) && (ts2 >= ceild(_PB_N-32,32))) {
    count++;;
  }
  if ((ts1 == 32*ts2) && (ts1 <= _PB_N-2)) {
    if (ts1%32 == 0) {
      count++;;
    }
  }
  if ((ts1 <= min(_PB_N-2,32*ts2+32)) && (ts1 >= 32*ts2+31)) {
    count++;;
    for (t3=ts2+1;t3<=floord(_PB_N-1,32);t3++) {
      count++;;
    }
  }
  if ((ts1 <= _PB_N-2) && (ts1 >= 32*ts2+33)) {
    count++;;
    t3 = floord(ts1,32);
    count++;;
  }
  if ((ts1 == _PB_N-1) && (ts1 == 32*ts2+32)) {
    if (ts1%32 == 0) {
      count++;;
    }
    if (ts1%32 == 0) {
      count++;;
    }
  }
  if ((ts1 == _PB_N-1) && (ts1 <= 32*ts2+31)) {
    count++;;
  }
  if ((ts1 == _PB_N-1) && (ts1 >= 32*ts2+33)) {
    count++;;
    t3 = floord(ts1,32);
    count++;;
  }
}
/* End of CLooG code */


return count;
}
