#include "polyrt.h"
#include "buffer_manager.h"
void data_tile_ref_count_init_A_0(int ts1,int ts2, double** A_trans,int A_size_1, BufferManager *buff_mang_A);
void read_in_data_tile_alloc_A_0(int ts1,int ts2, double** A_trans,int A_size_1, BufferManager *buff_mang_A);
#include "tbb/concurrent_priority_queue.h"

#include <omp.h>

#ifdef __DEBUG_FLUSH
#define IF_DEBUG_FLUSH(foo) foo
#else
#define IF_DEBUG_FLUSH(foo) 
#endif

#ifdef __DYNSCHEDULER_MORE_DEBUG_PRINT
#define IF_DYNSCHEDULER_MORE_DEBUG_PRINT(foo) foo
#else
#define IF_DYNSCHEDULER_MORE_DEBUG_PRINT(foo) 
#endif

#ifdef __DYNSCHEDULER_DEBUG_PRINT
#define IF_DYNSCHEDULER_DEBUG_PRINT(foo) foo
#else
#define IF_DYNSCHEDULER_DEBUG_PRINT(foo) 
#endif

extern FILE *__debug_print_fp;

class __Task {
	public:
		int loop;
		int id1;
		int id2;
		int local_dep_tasks;
		int thread_affinity;
		__Task() {}
		__Task(const int l, const int _id1, const int _id2, const int local, const int affinity) :
			loop(l),
			id1(_id1),
			id2(_id2),
			local_dep_tasks(local),
			thread_affinity(affinity) {}
		__Task(const __Task &task) :
			loop(task.loop),
			id1(task.id1),
			id2(task.id2),
			local_dep_tasks(task.local_dep_tasks),
			thread_affinity(task.thread_affinity) {}
		~__Task() {}
};

class __Compare {
	public:
		// returns true only if task2 has higher priority than task1
		bool operator()(const __Task &task1, const __Task &task2) const {
#ifndef __DYNSCHEDULER_NO_PRIORITY
			if (task2.local_dep_tasks>task1.local_dep_tasks) return true;
			if (task1.local_dep_tasks>task2.local_dep_tasks) return false;
			int thread_id = omp_get_thread_num();
			if ((thread_id == task2.thread_affinity) && (thread_id != task1.thread_affinity)) return true;
			if ((thread_id == task1.thread_affinity) && (thread_id != task2.thread_affinity)) return false;
			// lexicographic compare 
			if ( (task2.id1 > task1.id1) 
				|| ( (task2.id1 == task1.id1) && (task2.id2 > task1.id2) ) )
				 return true;
#endif
			return false;
		}
};

extern tbb::concurrent_priority_queue<__Task, __Compare> pqueue;

int get_num_local_dep_tasks_0(int ts1, int ts2, int _PB_N);
void local_update_dep_tasks_0(int ts1, int ts2, int _PB_N, int num_threads,int *tasks_loop0);
int get_num_local_src_tasks_0(int ts1, int ts2, int _PB_N);
extern int max_num_tasks_loop0_dim0;
extern int lb_tasks_loop0_dim0;
extern int max_num_tasks_loop0_dim1;
extern int lb_tasks_loop0_dim1;
extern int *tasks_loop0;
void init_tasks(int num_threads,long int *p_num_tasks_to_execute,int *tasks_loop0);
int pi_0( int t2, int t3, int _PB_N, int nprocs);
void data_tile_alloc_0(int ts1,int ts2, double** A_trans,int A_size_1, BufferManager *buff_mang_A);
void data_tile_ref_count_update_0(int ts1,int ts2, double** A_trans,int A_size_1, BufferManager *buff_mang_A);
void compute_task_0(int t1,int t2, double** A_trans,int A_size_1, BufferManager *buff_mang_A);
