#include "polyrt.h"
#include "buffer_manager.h"
#include "lu.dyn_data_dist.h"
#include <stdio.h>
#include <math.h>
#include <assert.h>
#define ceild(n,d)  ceil(((double)(n))/((double)(d)))
#define floord(n,d) floor(((double)(n))/((double)(d)))
#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))





int get_num_local_dep_tasks_0(int ts1, int ts2, int _PB_N)
{

int count = 0;


  int t1, t2, t3;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 >= ts2) && (ts1 <= 2*ts2) && (64*ts1 <= 64*ts2+_PB_N-65) && (64*ts2 <= _PB_N-1)) {
  if (ts1 <= min(floord(64*ts2+_PB_N-66,64),2*ts2-1)) {
    count++;;
  }
  if (ts1 >= 2*ts2-1) {
    for (t2=2*ts2+1;t2<=floord(64*ts2+_PB_N-1,64);t2++) {
      count++;;
    }
  }
}
/* End of CLooG code */


return count;
}

void local_update_dep_tasks_0(int ts1, int ts2, int _PB_N, int num_threads,int *tasks_loop0)
{
int remote_dep_tasks, local_dep_tasks, affinity, captured_firing_count;


  int t1, t2, t3;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((ts1 >= ts2) && (ts1 <= 2*ts2) && (64*ts1 <= 64*ts2+_PB_N-65) && (64*ts2 <= _PB_N-1)) {
  if (ts1 <= min(floord(64*ts2+_PB_N-66,64),2*ts2-1)) {
    
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(ts1+1 -lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(ts2-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(ts1+1, ts2,_PB_N); affinity = pi_0(ts1+1, ts2,_PB_N,num_threads); __Task task(0,ts1+1, ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, ts1+1, ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
  }
  if (ts1 >= 2*ts2-1) {
    for (t2=2*ts2+1;t2<=floord(64*ts2+_PB_N-1,64);t2++) {
      
#pragma omp atomic capture
 captured_firing_count = --tasks_loop0[(t2-lb_tasks_loop0_dim0)*max_num_tasks_loop0_dim1+(t2-ts2-lb_tasks_loop0_dim1)+0]; if (captured_firing_count == 0) { local_dep_tasks = get_num_local_dep_tasks_0(t2, t2-ts2,_PB_N); affinity = pi_0(t2, t2-ts2,_PB_N,num_threads); __Task task(0,t2, t2-ts2,local_dep_tasks,affinity); pqueue.push(task); IF_DYNSCHEDULER_MORE_DEBUG_PRINT( fprintf(__debug_print_fp, "added node %d loop 0 task %d %d                             local_dep_tasks %d ready tasks %lu\n", my_rank, t2, t2-ts2, local_dep_tasks, pqueue.size())); IF_DEBUG_FLUSH(fflush(__debug_print_fp)); };
    }
  }
}
/* End of CLooG code */

}

int get_num_local_src_tasks_0(int ts1, int ts2, int _PB_N)
{

int count = 0;


  int t1, t2, t3;

 int lbp, ubp;
 register int lbv, ubv;

/* Start of CLooG code */
if ((_PB_N >= 3) && (ts1 >= ts2) && (ts1 <= 2*ts2) && (64*ts1 <= 64*ts2+_PB_N-2) && (64*ts2 <= _PB_N-1)) {
  if ((ts1 == 1) && (ts2 == 1)) {
    count++;;
  }
  for (t2=max(ts1-ts2,2*ts1-2*ts2-1);t2<=min(ts1-2,2*ts1-2*ts2);t2++) {
    count++;;
  }
  if ((ts1 == 2*ts2-1) && (ts1 >= 3)) {
    if ((ts1+1)%2 == 0) {
      count++;;
    }
    if ((ts1+1)%2 == 0) {
      count++;;
    }
  }
  if ((ts1 >= ts2+1) && (ts1 <= 2*ts2-2)) {
    count++;;
  }
  if ((ts1 >= 2) && (ts1 == 2*ts2)) {
    if (ts1%2 == 0) {
      count++;;
    }
  }
}
/* End of CLooG code */


return count;
}
